;																		
;																		
; Dieses Assembler-Programm	generiert ein VGA-SIGNAL					
;																		
; ANALOGUHR + DCF77														
;																		
; 640x480 - 60HZ 														
; 																		
; 180x160 PIXEL															
;																		
; ATmega1284P-22MHz (bertaktet mit 10%)								
;																		
; AVR-STUDIO 4															
; Bernhard.Erfurt@gmx.de												
; VERSION: 07/2015														
;																		

;																		
; GRN leuchtet: alle-ok und alles schn								
; GELB leuchtet:														
; ROT  leuchtet: die automatische Taktkorrektur im Interrupt versagt	
; ROT+GELB leuchtet: Zeilennummern stimmen nicht 						

;																		
; Blinken die LEDs, das ist nicht gut !									
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf					
;																		

;																		
; Die Pixel generiert der PORT-B, ist aber	dadurch komplett belegt		
;																		


;												
; Anschlussbelegung PINS						
;												
; PA0 ==> 										
; PA1 ==> 										
; PA2 ==> 										
; PA3 ==> 										
; PA4 ==> 										
; PA5 ==> 										
; PA6 ==> 										
; PA7 ==> 										
;												
; PB0 ==> ROT									
; PB1 ==> GRN									
; PB2 ==> BLAU									
; PB3 ==>										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> TEST-AUSGANG-B						
; PC4 ==> TEST-AUSGANG-A						
; PC5 ==> LED GRN								
; PC6 ==> LED GELB								
; PC7 ==> LED ROT								
;												
; PD0 ==> VSYNC									
; PD1 ==> HSYNC									
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> OUT ca.32kHz							
;												

; ATmega1284P 									
.include "m1284pdef.inc"
; KONSTANTEN									
.equ TAKT									= 22000000	; 22 MHz		
; DCF-PHASENKORREKTUR-WARTEZEIT					
.equ DCF_PHASENKORREKTUR_WARTEZEIT			= 16	    ;(6) nach einigen Sekunden Phase schieben					
; VGA											
.equ VGA_X									= 180
.equ VGA_Y									= 160
.equ VGA_ZEILEN_PRO_PIXEL					= 3
.equ VGA_BYTES_PRO_ZEILE					= 90
; TIMER-0-WERTE	(RESERVE)						
.equ TIMER0_CTC_FREQUENZ					= 10000
.equ TIMER0_N								= 8
.equ TIMER0_CTC								=(TAKT/(2*TIMER0_N*TIMER0_CTC_FREQUENZ))-1
.equ TIMER0_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER0_N)*(1+TIMER0_CTC))
; TIMER-1-WERTE	(VGA-BILD)						
.equ TIMER1_CTC_FREQUENZ					= 31496/2
.equ TIMER1_N								= 1
.equ TIMER1_CTC								=(TAKT/(2*TIMER1_N*TIMER1_CTC_FREQUENZ))-1
.equ TIMER1_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER1_N)*(1+TIMER1_CTC))
; TIMER-2-WERTE (ca. 32kHz fr Sensor)			
.equ TIMER2_CTC_FREQUENZ					= 32000
.equ TIMER2_N								= 8
.equ TIMER2_CTC								=(TAKT/(2*TIMER2_N*TIMER2_CTC_FREQUENZ))-1
.equ TIMER2_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER2_N)*(1+TIMER2_CTC))
; TIMER-3-WERTE (20ms fr Uhr + DCF)			
.equ TIMER3_CTC_FREQUENZ					= 25
.equ TIMER3_N								= 64
.equ TIMER3_CTC								=(TAKT/(2*TIMER3_N*TIMER3_CTC_FREQUENZ))-1
.equ TIMER3_FREQUENZ_BERECHNET				=TAKT*10/(2*(TIMER3_N)*(1+TIMER3_CTC))
; TWI-SCL										
.equ TWI_SCL_PIN_NR							= 0
.equ TWI_SCL_PORT							= PORTC
.equ TWI_SCL_PIN							= PINC
; TWI-SDA										
.equ TWI_SDA_PIN_NR							= 1
.equ TWI_SDA_PORT							= PORTC
.equ TWI_SDA_PIN							= PINC
; TEST-B-PIN									
.equ TESTB_PIN_NR							= 3
.equ TESTB_DDR								= DDRC
.equ TESTB_PORT								= PORTC
; TEST-A-PIN									
.equ TESTA_PIN_NR							= 4
.equ TESTA_DDR								= DDRC
.equ TESTA_PORT								= PORTC
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR						= 5
.equ LED_GRUEN_DDR							= DDRC
.equ LED_GRUEN_PORT							= PORTC
; LED-GELB										
.equ LED_GELB_PIN_NR						= 6
.equ LED_GELB_DDR							= DDRC
.equ LED_GELB_PORT							= PORTC
; LED-ROT										
.equ LED_ROT_PIN_NR							= 7
.equ LED_ROT_DDR							= DDRC
.equ LED_ROT_PORT							= PORTC
; VGA-RGB-DATA-PORT								
.equ RGB_DATA_DDR							= DDRB
.equ RGB_DATA_PORT							= PORTB
; VGA-ROT-GRN-BLAU								
.equ R_DATA_PIN_NR							= 0
.equ G_DATA_PIN_NR							= 1
.equ B_DATA_PIN_NR							= 2
; VGA-V-SYNCHRON(BILDANFANG)					
.equ VSYNC_PIN_NR							= 0
.equ VSYNC_DDR								= DDRD
.equ VSYNC_PORT								= PORTD
; VGA-H-SYNCHRON (ZEILE)						
.equ HSYNC_PIN_NR							= 1
.equ HSYNC_DDR								= DDRD
.equ HSYNC_PORT								= PORTD
; DCF-EINGANG									
.equ DCF_PIN_NR								= 2
.equ DCF_DDR								= DDRD
.equ DCF_PORT								= PORTD
.equ DCF_PIN								= PIND
; ERROR-CODES									
.equ ERROR_DCF_PHASE						= 10
.equ ERROR_DCF_MINUTENENDE					= 59
.equ ERROR_DCF_NO_ANFANGSBIT				= 100
.equ ERROR_DCF_RESERVEANTENNE				= 215	; nur INFO, kein ERROR	
.equ ERROR_DCF_ZEITUMSTELLUNG				= 216	; nur INFO, kein ERROR	
.equ ERROR_DCF_MESZ							= 118
.equ ERROR_DCF_SCHALTSEKUNDE				= 119
.equ ERROR_DCF_NO_ZEITINFORMATIONSBIT		= 120
.equ ERROR_DCF_MINUTE						= 127
.equ ERROR_DCF_PARITAET_MINUTE				= 128
.equ ERROR_DCF_STUNDE						= 134
.equ ERROR_DCF_PARITAET_STUNDE				= 135
.equ ERROR_DCF_TAG							= 141
.equ ERROR_DCF_WOCHENTAG					= 144
.equ ERROR_DCF_MONAT						= 149
.equ ERROR_DCF_JAHR							= 157
.equ ERROR_DCF_PARITAET_DATUM				= 158


; REGISTER												
.def HILFSREGISTER_R0=R0	; wichtiges Rechenregister	
.def HILFSREGISTER_R1=R1	; wichtiges Rechenregister	
.def HILFSREGISTER_R2=R2	; wichtiges Rechenregister	
.def HILFSREGISTER_R3=R3	; wichtiges Rechenregister	
.def HILFSREGISTER_R4=R4	; wichtiges Rechenregister	
.def HILFSREGISTER_R5=R5	; wichtiges Rechenregister	
.def HILFSREGISTER_R6=R6	; wichtiges Rechenregister	
.def HILFSREGISTER_R7=R7	; wichtiges Rechenregister	
.def SREG_KOPIE		= R8	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def temp_KOPIE		= R9	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YL_KOPIE		= R10	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YH_KOPIE		= R11	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZL_KOPIE		= R12	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZH_KOPIE		= R13	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def NULL 			= R14	; ist immer NULL 	
.def EINS 			= R15	; ist immer EINS 	
.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)		
.equ adr_DATEN							=SRAM_START+0		
	
.equ adr_MODUS_START					=SRAM_START+1		; Modus bei Programmstart	
.equ adr_MODUS							=SRAM_START+2		; MODUS (z.B. 1=Uhr)		
.equ adr_MENUE							=SRAM_START+3		; MENUE						
.equ adr_ERROR_CODE						=SRAM_START+4		; ERROR CODE 				
.equ adr_ERROR_WERT						=SRAM_START+5		; ERROR CODE (WERT)			
.equ adr_WARNUNG_CODE					=SRAM_START+6		; Warnung Code				
.equ adr_WARNUNG_WERT					=SRAM_START+7		; Warnung Code (WERT)		

.equ adr_FEHLER_SPEICHER80				=SRAM_START+100		; 


.equ adr_ss20							=SRAM_START+700		; 20ms Sekunden				
.equ adr_ss								=SRAM_START+701		; Sekunden					
.equ adr_mm								=SRAM_START+702		; Minuten					
.equ adr_hh								=SRAM_START+703		; Stunden					
.equ adr_TAG							=SRAM_START+704		; TAG						
.equ adr_MONAT							=SRAM_START+705		; Monat						
.equ adr_JAHR							=SRAM_START+706		; JAHR						
.equ adr_WOCHENTAG						=SRAM_START+707		; 1=Mo 7=So					
.equ adr_MESZ							=SRAM_START+708

.equ adr_ANALOGUHR_OLD_ss				=SRAM_START+720		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_ss		=SRAM_START+721		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_mm		=SRAM_START+722		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_hh		=SRAM_START+723		; ANALOGUHR					
.equ adr_ANALOGUHR_ZEIGER_OLD_hhmm		=SRAM_START+724		; ANALOGUHR					

.equ adr_DCF_ss20						=SRAM_START+900	; 20ms Sekunden					
.equ adr_DCF_ss							=SRAM_START+901	; SEKUNDEN						
.equ adr_DCF_mm							=SRAM_START+902	; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_hh							=SRAM_START+903	; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_TAG						=SRAM_START+904	; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG					=SRAM_START+905	; WochenTag aus DCF-Protokoll	
.equ adr_DCF_MONAT						=SRAM_START+906	; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR						=SRAM_START+907	; Jahr	 	 aus DCF-Protokoll	
.equ adr_DCF_MESZ						=SRAM_START+908	; SOMMERZEIT aus DCF-Protokoll	
.equ adr_DCF_PHASE						=SRAM_START+909	; 
.equ adr_DCF_PHASE_WAIT					=SRAM_START+910	; 
.equ adr_DCF_SIGNAL_INVERTIEREN			=SRAM_START+911	; 
.equ adr_DCF_SIGNAL_ZAEHLER				=SRAM_START+912	; 
.equ adr_DCF_TRAEGER					=SRAM_START+913	; 
.equ adr_DCF_TRAEGER_OLD				=SRAM_START+914	;
.equ adr_DCF_SAMPLES_A					=SRAM_START+915	; SAMPLES_A (100ms)				
.equ adr_DCF_SAMPLES_B					=SRAM_START+916	; SAMPLES_B (200ms)				
.equ adr_DCF_MINUTENENDE				=SRAM_START+917
.equ adr_DCF_PROTOKOLL_OK				=SRAM_START+918
.equ adr_DCF_NO_BERECHNUNG				=SRAM_START+919
.equ adr_DCF_ERROR_CODE					=SRAM_START+920	; DCF-ERROR-CODE				
.equ adr_DCF_GUELTIG					=SRAM_START+921	; DCF-Protokoll ist geprft und gltig			
.equ adr_DCF_HEUTE_EMPFANGEN			=SRAM_START+922	; DCF-Protokoll heute schon komplett empfangen	
.equ adr_DCF_LAST_SYNCHRONISATION_mm	=SRAM_START+923	; letztes erfolgreiches DCF-Protokoll			
.equ adr_DCF_LAST_SYNCHRONISATION_hh	=SRAM_START+924
.equ adr_DCF_LAST_SYNCHRONISATION_TAG	=SRAM_START+925
.equ adr_DCF_LAST_SYNCHRONISATION_MONAT	=SRAM_START+926
.equ adr_DCF_LAST_SYNCHRONISATION_JAHR	=SRAM_START+927
.equ adr_DCF_BEREICH60					=SRAM_START+928	; 60 BYTES fr DCF-FELD	

.equ adr_GRAFIC_FARBE					=SRAM_START+1100	; 0=wei 1=schwarz			
.equ adr_GRAFIC_PUNKT_GROESSE			=SRAM_START+1101	; PUNKT-GRSSE 0...9		
.equ adr_GRAFIC_ASCII_CURSOR_ZEILE		=SRAM_START+1102	; CURSOR VGA-ZEILE 			
.equ adr_GRAFIC_ASCII_CURSOR_SPALTE		=SRAM_START+1103	; CURSOR-SPALTE (0..		
.equ adr_GRAFIC_X1						=SRAM_START+1104	; X1-KOORDINATEN
.equ adr_GRAFIC_Y1						=SRAM_START+1105	; Y1-KOORDINATEN
.equ adr_GRAFIC_X2						=SRAM_START+1106	; X2-KOORDINATEN
.equ adr_GRAFIC_Y2						=SRAM_START+1107	; Y2-KOORDINATEN
.equ adr_GRAFIC_RADIUS_L				=SRAM_START+1108	; RADIUS					
.equ adr_GRAFIC_RADIUS_H				=SRAM_START+1109	; RADIUS					
.equ adr_GRAFIC_WINKEL_L				=SRAM_START+1110	; WINKEL					
.equ adr_GRAFIC_WINKEL_H				=SRAM_START+1111	; WINKEL					
.equ adr_GRAFIC_ZEIGER_LAENGE			=SRAM_START+1112	; STRECKEN-LNGE			








.equ adr_VGA_TURBO_ON				=SRAM_START+1500
.equ adr_VGA_TURBO_OFF				=SRAM_START+1501
.equ adr_VGA_TURBO_DUMMY			=SRAM_START+1502
.equ adr_VGA_BILDZEILEN_NR_L		=SRAM_START+1503		; BILD-ZEILENNUMMER					
.equ adr_VGA_BILDZEILEN_NR_H		=SRAM_START+1504
.equ adr_VGA_ZEIGER_DATA_L			=SRAM_START+1505		; ZEIGER fr BILD-DATEN				
.equ adr_VGA_ZEIGER_DATA_H			=SRAM_START+1506
.equ adr_VGA_PIXEL_ZEILEN_COUNTER	=SRAM_START+1507		; PIXELZEILE						
.equ adr_VGA_BILD_ZEILE				=SRAM_START+1508
.equ adr_VGA_TURBO_BEREICH160		=SRAM_START+1510

.equ adr_VGA_BILDBEREICH			=SRAM_START+1800		; BILDSPEICHER						
.equ adr_VGA_BILDBEREICH_ENDE		=SRAM_START+1800+14400-1;(180x160/2 = 14.400 Bytes)			

.equ adr_SRAM_CHECK					=SRAM_START+16300		; SRAM CHECK muss immer "S" sein	
.equ adr_SRAM_END					=SRAM_START+16383		; 


;---------------------------------------------------------------------------
.cseg							;Beginn eines Code-Segmentes				
.org 0							;Startadresse=0								
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 		; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp TIM1_COMPA ; Timer1 CompareA				
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;TIM1_OVF 	; Timer1 Overflow				
.org 0x0020 rjmp INTERRUPT_ERROR ;TIM0_COMPA ; Timer0 CompareA				
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp INTERRUPT_ERROR ;rjmp TIM3_OVF 	; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	CLI											; INTERRUPTS sperren	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM_CLEAR										
	call SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; DATUM				
	ldi temp,1
	STS(adr_TAG),temp
	ldi temp,1
	STS(adr_MONAT),temp
	ldi temp,16
	STS(adr_JAHR),temp
	ldi temp,5
	STS(adr_WOCHENTAG),temp
	ldi temp,0
	STS(adr_MESZ),temp	; MESZ	
	; ZEIT				
	ldi temp,20
	STS(adr_hh),temp	; hh	
	ldi temp,0
	STS(adr_mm),temp	; mm	
	ldi temp,0
	STS(adr_ss),temp	; ss	
	ldi temp,0
	STS(adr_DCF_ss),temp; DCF-ss
; PORT A+B+C+D initialisieren (alles EINGNGE+PULL-UP aus)	
	out DDRA, NULL
	out PORTA,NULL
	out DDRB, NULL
	out PORTB,NULL
	out DDRC, NULL
	out PORTC,NULL
	out DDRD, NULL
	out PORTD,NULL
; LED_INITIALISIERUNG										
	call LED_INITIALISIERUNG
; WDR_INITIALISIERUNG										
	call WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR											
;	call NEUSTART_MIT_WDR
; VGA_PIN_INITIALISIERUNG									
	call VGA_PIN_INITIALISIERUNG
; DCF-INITIALISIERUNG										
	call DCF_INITIALISIERUNG
; TIMER INITALISIERUNG										
;	call TIMER0_INITIALISIERUNG_CTC
	call TIMER1_INITIALISIERUNG_CTC	; VGA-BILD				
	call TIMER2_INITIALISIERUNG_CTC	; FREQUENZ				
	call TIMER3_INITIALISIERUNG_CTC	; UHR					
; Interrupts freigeben										
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EINSCHWINGEN												
	call GRAFIC_CLEAR				; LED_TEST		
	call VGA_TEST_FARBBALKEN
	call LED_TEST 
	call wait_50ms
	call GRAFIC_CLEAR
;-------------------------------------------------------------------------------
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   	
	call PROGRAMM_CHECK
;-------------------------------------------------------------------------------
	call VGA_TESTS
	call ANALOGUHR_INITIALISIERUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
;	call ANZEIGE_HAUPTMENUE
;	call ANZEIGE_FEHLERSPEICHER
;	call ANZEIGE_WARTUNG_DCF

	call ANALOGUHR


	call PROGRAMM_CHECK
	call ANZEIGE_ERROR_CODE
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "VGA_TIMER.asm"					; TIMER							
.include "VGA_BILD_MACRO.asm"				; BILDAUFBAU					
.include "VGA_BILD.asm"						; TIMER+BILDAUFBAU				
.include "VGA_ASCII.asm"					; ASCII							
.include "VGA_ASCII_ALPHABET.asm"			; ASCII Alphabet				
.include "VGA_ANZEIGE.asm"					; ANZEIGE						
.include "VGA_ANZEIGE_ZAHLEN.asm"			; ZAHLEN						
.include "VGA_ANZEIGE_KURZ.asm"				; ANZEIGE						
.include "VGA_DCF77.asm"					; DCF77							
.include "VGA_GRAFIC.asm"					; GRAFIC allgemein				
.include "VGA_GRAFIC_PUNKT.asm"				; PUNKT							
.include "VGA_GRAFIC_PUNKT_AUF_KREIS.asm"	; PUNKT auf KREIS				
.include "VGA_GRAFIC_LINIE.asm"				; LINIE							
.include "VGA_GRAFIC_RECHTECK.asm"			; RECHTECK						
.include "VGA_GRAFIC_ZEIGER.asm"			; ZEIGER						
.include "VGA_FUNKTIONEN.asm"				; FUNKTIONEN					
.include "VGA_SONSTIGES.asm"				; sonstiges						
.include "VGA_GRAFIC_TESTS.asm"				; TESTBILDER					
.include "VGA_WAIT_22MHZ.asm"				; 20 MHz						
.include "VGA_ANALOGUHR.asm"				; ANALOGUHR						
.include "VGA_TABELLE_ASCII_8x12.asm"		; TABELLE (umfangreich)			
.include "VGA_TABELLE_SINUS_COSINUS.asm"	; TABELLE (umfangreich)			
; ##############################################################################
; ##############################################################################
; ##############################################################################

TEXT_BEGRUESSUNG_0:
.db "VGA 640x480 60Hz ",0
TEXT_BEGRUESSUNG_1:
.db " ",0
TEXT_BEGRUESSUNG_2:
.db "180 x 160 PIXEL",0
TEXT_BEGRUESSUNG_3:
.db " ",0
TEXT_BEGRUESSUNG_4:
.db "ASCII 22x13 (8x12) ",0
TEXT_BEGRUESSUNG_5:
.db " ",0
TEXT_BEGRUESSUNG_6:
.db "ATmega1284P 22MHz",0
TEXT_BEGRUESSUNG_7:
.db " ",0
TEXT_BEGRUESSUNG_8:
.db "ANALOGUHR",0
TEXT_BEGRUESSUNG_9:
.db " ",0
TEXT_BEGRUESSUNG_10:
.db "DCF-77 ",0
TEXT_BEGRUESSUNG_11:
.db " ",0
TEXT_BEGRUESSUNG_12:
.db "V1 07/2015 ",0
